package ezc.tests;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.Collection;
import java.util.GregorianCalendar;

import org.junit.Test;

import ezc.model.Annuncio;
import ezc.model.TipologiaImmobile;
import ezc.ui.MyController;

public class MyControllerTests
{
	
	private ArrayList<Annuncio> getAnnunci()
	{
		GregorianCalendar gc = new GregorianCalendar();
		gc.add(GregorianCalendar.DAY_OF_YEAR, -2);
		ArrayList<Annuncio> annunci = new ArrayList<Annuncio>();
		annunci.add(new Annuncio("V123", TipologiaImmobile.MONOLOCALE, 110, "Descrizione", "Ravenna", "Stadio", 220, true, true, gc.getTime()));
		annunci.add(new Annuncio("V124", TipologiaImmobile.MONOLOCALE, 110, "Descrizione", "Ravenna", "Stadio", 220, true, true, gc.getTime()));
		annunci.add(new Annuncio("V125", TipologiaImmobile.MONOLOCALE, 110, "Descrizione", "Ravenna", "Porto", 220, true, true, gc.getTime()));
		annunci.add(new Annuncio("V126", TipologiaImmobile.MONOLOCALE, 110, "Descrizione", "Ravenna", "Porto", 220, true, true, gc.getTime()));
		annunci.add(new Annuncio("V127", TipologiaImmobile.MONOLOCALE, 110, "Descrizione", "Bologna", "San Ruffillo", 220, true, true, gc.getTime()));
		annunci.add(new Annuncio("V128", TipologiaImmobile.MONOLOCALE, 110, "Descrizione", "Bologna", "San Ruffillo", 220, true, true, gc.getTime()));
		return annunci;
	}

	@Test
	public void testGetElencoCitta()
	{
		MyController c = new MyController(getAnnunci());
		Collection<String> out = c.getElencoCitta();
		
		assertEquals(2, out.size());
		assertTrue(containsIgnoreCase(out, "Ravenna"));
		assertTrue(containsIgnoreCase(out, "Bologna"));
	}

	@Test
	public void testGetElencoZone()
	{
		MyController c = new MyController(getAnnunci());
		Collection<String> out = c.getElencoZone("Ravenna");
		
		assertEquals(2, out.size());
		assertTrue(containsIgnoreCase(out, "Stadio"));
		assertTrue(containsIgnoreCase(out, "Porto"));
	}
	
	public boolean containsIgnoreCase(Collection<String> collection, String toFind)
	{
		for (String s : collection)
		{
			if (s.equalsIgnoreCase(toFind))
			{
				return true;
			}
		}
		return false;
	}

}
