package ezc.ui;

import java.util.Collection;
import java.util.Comparator;
import java.util.SortedSet;
import java.util.TreeSet;

import ezc.model.Annuncio;
import ezc.model.Filtro;
import ezc.model.PrezzoComparator;
import ezc.model.RicercaAnnunci;

public class MyController implements Controller
{
	private Collection<Annuncio> annunci;
	private Comparator<Annuncio> defaultComparator;

	public MyController(Collection<Annuncio> annunci)
	{
		this.annunci = annunci;
		this.defaultComparator = new PrezzoComparator();
	}

	@Override
	public Collection<Annuncio> ricerca(Filtro filtro)
	{
		return RicercaAnnunci.cerca(annunci, filtro, defaultComparator);
	}

	@Override
	public Collection<String> getElencoCitta()
	{
		SortedSet<String> elencoCitta = new TreeSet<String>();
		for (Annuncio annuncio : annunci)
		{
			elencoCitta.add(annuncio.getCitta().toUpperCase());	//Il Set scarta i duplicati!
		}
		return elencoCitta;
	}

	@Override
	public Collection<String> getElencoZone(String citta)
	{
		SortedSet<String> elencoZone = new TreeSet<String>();
		for (Annuncio annuncio : annunci)
		{
			if (annuncio.getCitta().equalsIgnoreCase(citta))
			{
				elencoZone.add(annuncio.getZona().toUpperCase());	//Il Set scarta i duplicati!
			}
		}
		return elencoZone;
	}
}
